Index: src/tests/.expect/memberCtors.txt
===================================================================
--- src/tests/.expect/memberCtors.txt	(revision ddbde341505b2fb04a0b5e0bb7d30a38fe431ded)
+++ src/tests/.expect/memberCtors.txt	(revision 1461809e5a521b8de29e85716c8e7d81a9059052)
@@ -7,19 +7,19 @@
 constructing int
 begin construct B
-assign b->a2
-constructing int
-constructing int
-begin construct A
-construct a->x
+assign b.a2
+constructing int
+constructing int
+begin construct A
+construct a.x
 constructing int: 1001
-assign a->y
-assigning int: 0 0
-end construct A
-copy constructing int: 0
-copy constructing int: 0
-begin copy construct A
-copy construct this->x
-copy constructing int: 1001
-assign this->y
+assign a.y
+assigning int: 0 0
+end construct A
+copy constructing int: 0
+copy constructing int: 0
+begin copy construct A
+copy construct this.x
+copy constructing int: 1001
+assign this.y
 copy constructing int: 0
 destructing int: 0
@@ -40,24 +40,24 @@
 copy constructing int: 0
 begin copy construct A
-copy construct this->x
-copy constructing int: 1001
-assign this->y
-copy constructing int: 0
-destructing int: 0
-destructing int: 0
-end copy construct A
-destructing int: 0
-destructing int: 0
-destructing int: 1001
-destructing int: 0
-destructing int: 0
-destructing int: 1001
-construct b->a1
-constructing int
-constructing int
-begin construct A
-construct a->x
+copy construct this.x
+copy constructing int: 1001
+assign this.y
+copy constructing int: 0
+destructing int: 0
+destructing int: 0
+end copy construct A
+destructing int: 0
+destructing int: 0
+destructing int: 1001
+destructing int: 0
+destructing int: 0
+destructing int: 1001
+construct b.a1
+constructing int
+constructing int
+begin construct A
+construct a.x
 constructing int: 1000
-assign a->y
+assign a.y
 assigning int: 0 0
 end construct A
@@ -70,27 +70,27 @@
 copy constructing int: 0
 begin copy construct A
-copy construct this->x
+copy construct this.x
 copy constructing int: 1000
-assign this->y
-copy constructing int: 0
-destructing int: 0
-destructing int: 0
-end copy construct A
-copy constructing int: 0
-copy constructing int: 0
-begin copy construct A
-copy construct this->x
-copy constructing int: 1001
-assign this->y
-copy constructing int: 0
-destructing int: 0
-destructing int: 0
-end copy construct A
-copy constructing int: 0
-copy constructing int: 0
-begin copy construct A
-copy construct this->x
-copy constructing int: 0
-assign this->y
+assign this.y
+copy constructing int: 0
+destructing int: 0
+destructing int: 0
+end copy construct A
+copy constructing int: 0
+copy constructing int: 0
+begin copy construct A
+copy construct this.x
+copy constructing int: 1001
+assign this.y
+copy constructing int: 0
+destructing int: 0
+destructing int: 0
+end copy construct A
+copy constructing int: 0
+copy constructing int: 0
+begin copy construct A
+copy construct this.x
+copy constructing int: 0
+assign this.y
 copy constructing int: 0
 destructing int: 0
@@ -101,15 +101,15 @@
 constructing int
 begin construct A
-construct a->x
+construct a.x
 constructing int: 999
-assign a->y
-assigning int: 0 0
-end construct A
-copy constructing int: 0
-copy constructing int: 0
-begin copy construct A
-copy construct this->x
-copy constructing int: 999
-assign this->y
+assign a.y
+assigning int: 0 0
+end construct A
+copy constructing int: 0
+copy constructing int: 0
+begin copy construct A
+copy construct this.x
+copy constructing int: 999
+assign this.y
 copy constructing int: 0
 destructing int: 0
@@ -130,7 +130,7 @@
 copy constructing int: 0
 begin copy construct A
-copy construct this->x
-copy constructing int: 999
-assign this->y
+copy construct this.x
+copy constructing int: 999
+assign this.y
 copy constructing int: 0
 destructing int: 0
@@ -158,15 +158,15 @@
 constructing int
 begin construct A
-construct a->x
+construct a.x
 constructing int: 999
-assign a->y
-assigning int: 0 0
-end construct A
-copy constructing int: 0
-copy constructing int: 0
-begin copy construct A
-copy construct this->x
-copy constructing int: 999
-assign this->y
+assign a.y
+assigning int: 0 0
+end construct A
+copy constructing int: 0
+copy constructing int: 0
+begin copy construct A
+copy construct this.x
+copy constructing int: 999
+assign this.y
 copy constructing int: 0
 destructing int: 0
@@ -187,7 +187,7 @@
 copy constructing int: 0
 begin copy construct A
-copy construct this->x
-copy constructing int: 999
-assign this->y
+copy construct this.x
+copy constructing int: 999
+assign this.y
 copy constructing int: 0
 destructing int: 0