Index: benchmark/schedext/cfa1.cfa
===================================================================
--- benchmark/schedext/cfa1.cfa	(revision cca568e32a0a35aff9eb80fa5e403e3d338d349e)
+++ benchmark/schedext/cfa1.cfa	(revision 2316525c0ab1029715c0c8bc2f6fe53ca84525fe)
@@ -4,28 +4,25 @@
 #include <stdio.h>
 
-#include "bench.h"
+#include "../bench.h"
 
 volatile int go = 0;
 
-monitor M {};
-M m1;
+monitor M {} m1;
 
-void __attribute__((noinline)) call( M & mutex a1 ) {}
+void __attribute__((noinline)) call( M & mutex p1 ) {}
 
-int  __attribute__((noinline)) wait( M & mutex a1 ) {
+void __attribute__((noinline)) wait( M & mutex p1 ) {
 	go = 1;
-	for ( i; times ) {
-		waitfor(call : a1);
+	for ( times ) {
+		waitfor( call : p1 );
 	}
 	go = 0;
-	return 0;
 }
 
 thread T {};
-void ^?{}( T & mutex this ) {}
 void main( T & ) {
-	while(go == 0) { yield(); }
+	while ( go == 0 ) { yield(); }
 	BENCH(
-		while(go == 1) { call(m1); },
+		while ( go == 1 ) { call( m1 ); },
 		result
 	)
@@ -36,5 +33,5 @@
 	BENCH_START()
 	T t;
-	return wait( m1 );
+	wait( m1 );
 }
 
Index: benchmark/schedext/cfa2.cfa
===================================================================
--- benchmark/schedext/cfa2.cfa	(revision cca568e32a0a35aff9eb80fa5e403e3d338d349e)
+++ benchmark/schedext/cfa2.cfa	(revision 2316525c0ab1029715c0c8bc2f6fe53ca84525fe)
@@ -8,24 +8,21 @@
 volatile int go = 0;
 
-monitor M {};
-M m1, m2;
+monitor M {} m1, m2;
 
-void __attribute__((noinline)) call( M & mutex a1, M & mutex a2 ) {}
+void __attribute__((noinline)) call( M & mutex p1, M & mutex p2 ) {}
 
-int  __attribute__((noinline)) wait( M & mutex a1, M & mutex a2 ) {
+void __attribute__((noinline)) wait( M & mutex p1, M & mutex p2 ) {
 	go = 1;
-	for ( i; times ) {
-		waitfor(call : a1, a2);
+	for ( times ) {
+		waitfor( call : p1, p2 );
 	}
 	go = 0;
-	return 0;
 }
 
 thread T {};
-void ^?{}( T & mutex this ) {}
 void main( T & ) {
-	while(go == 0) { yield(); }
+	while( go == 0 ) { yield(); }
 	BENCH(
-		while(go == 1) { call(m1, m2); },
+		while ( go == 1 ) { call( m1, m2 ); },
 		result
 	)
@@ -36,5 +33,5 @@
 	BENCH_START()
 	T t;
-	return wait( m1, m2 );
+	wait( m1, m2 );
 }
 
Index: benchmark/schedext/cfa4.cfa
===================================================================
--- benchmark/schedext/cfa4.cfa	(revision cca568e32a0a35aff9eb80fa5e403e3d338d349e)
+++ benchmark/schedext/cfa4.cfa	(revision 2316525c0ab1029715c0c8bc2f6fe53ca84525fe)
@@ -8,24 +8,21 @@
 volatile int go = 0;
 
-monitor M {};
-M m1, m2, m3, m4;
+monitor M {} m1, m2, m3, m4;
 
-void __attribute__((noinline)) call( M & mutex a1, M & mutex a2, M & mutex a3, M & mutex a4 ) {}
+void __attribute__((noinline)) call( M & mutex p1, M & mutex p2, M & mutex p3, M & mutex p4 ) {}
 
-int  __attribute__((noinline)) wait( M & mutex a1, M & mutex a2, M & mutex a3, M & mutex a4 ) {
+void __attribute__((noinline)) wait( M & mutex p1, M & mutex p2, M & mutex p3, M & mutex p4 ) {
 	go = 1;
-	for ( i; times ) {
-		waitfor( call : a1, a2, a3, a4 );
+	for ( times ) {
+		waitfor( call : p1, p2, p3, p4 );
 	}
 	go = 0;
-	return 0;
 }
 
 thread T {};
-void ^?{}( T & mutex this ) {}
 void main( T & ) {
-	while(go == 0) { yield(); }
+	while( go == 0 ) { yield(); }
 	BENCH(
-		while(go == 1) { call(m1, m2, m3, m4); },
+		while( go == 1 ) { call( m1, m2, m3, m4 ); },
 		result
 	)
@@ -36,5 +33,5 @@
 	BENCH_START()
 	T t;
-	return wait( m1, m2, m3, m4 );
+	wait( m1, m2, m3, m4 );
 }
 
Index: benchmark/schedext/upp.cc
===================================================================
--- benchmark/schedext/upp.cc	(revision cca568e32a0a35aff9eb80fa5e403e3d338d349e)
+++ benchmark/schedext/upp.cc	(revision 2316525c0ab1029715c0c8bc2f6fe53ca84525fe)
@@ -11,5 +11,5 @@
 	int __attribute__((noinline)) wait() {
 		go = 1;
-		for (size_t i = 0; i < times; i++) {
+		for ( size_t i = 0; i < times; i++ ) {
 			_Accept(call);
 		}
@@ -17,13 +17,11 @@
 		return 0;
 	}
-};
-
-M m;
+} m;
 
 _Task T {
 	void main() {
-		while(go == 0) { yield(); }
+		while ( go == 0 ) { yield(); }
 		BENCH(
-			while(go == 1) { m.call(); },
+			while ( go == 1 ) { m.call(); },
 			result
 		)